;####################################################
; WoodStock Logo v.1.0 : Examples
;####################################################
; Informatik 1A: Projekt
;----------------------------------------------------
; BROCCO Amos
; BALABBIO Mara
; STOJANOVIC Tanja
;####################################################

(define KochTriangle (cons 'begin '(
(define (Koch turtle s n)
  (if (= n 0)
      (forward turtle s)
      (let ((s-new (/ s 3))
            (n-new (- n 1)))
        (koch turtle s-new n-new)
        (left turtle 60)
        (koch turtle s-new n-new)
        (right turtle 120)
        (koch turtle s-new n-new)
        (left turtle 60)
        (koch turtle s-new n-new))))

(define (KochTriangle turtle s n)
(repeat 3
        (Koch turtle s n)
        (right turtle 120)))

(clearscreen)
(maketurtle tu)
(setpencolor tu "red")
(pendown tu)
(kochtriangle tu 200 3))))



(define Treppe (cons 'begin '(
(define (treppe tu1 tu2 side n)
  (setangle tu1 0)
  (setangle tu2 180)
  (repeat n
          (forward tu1 side)
          (right tu1 90)
          (forward tu1 side)
          (left tu1 90)
          (forward tu2 side)
          (left tu2 90)
          (forward tu2 side)
          (right tu2 90)))

(clearscreen)
(maketurtle turtle1)
(maketurtle turtle2)
(pendown turtle1)
(pendown turtle2)
(setpencolor turtle1 "blue")
(setpencolor turtle2 "red")
(treppe turtle1 turtle2 20 5))))


(define MoveOnLine (cons 'begin '(
(define (drawline turtle angle s)
  (pushturtle turtle)
  (setangle turtle angle)
  (forward turtle (/ s 2))
  (back turtle s)
  (popturtle turtle))
(maketurtle tu2)
(pendown tu2)
(define (MoveOnLine turtle s inc-angle n inc-pos)
  (define (iter new-angle n)
    (if (> n 0)
        (begin
          (DrawLine turtle new-angle s)
          (penup turtle)
          (forward turtle inc-pos)
          (pendown turtle)
          (iter (+ new-angle inc-angle) (- n 1)))))
    (iter 0 n))
(clearscreen)
(setpencolor tu2 "green")
(setpos tu2 -150 0)
(moveonline tu2 60 6 121 3))))

(define MoveOnCircle (cons 'begin '(
(define (drawline turtle angle s)
  (pushturtle turtle)
  (setangle turtle angle)
  (forward turtle (/ s 2))
  (back turtle s)
  (popturtle turtle))
(maketurtle tu3)
(setpencolor tu3 "dark olive green")

(define (MoveOnCircle turtle s inc-angle n inc-pos)
  (define (iter new-angle i)
    (if (> i 0)
        (begin
          (DrawLine turtle new-angle s)
          (penup turtle)
          (forward turtle inc-pos)
          (left turtle (/ 360 n))
          (pendown turtle)
          (iter (+ new-angle inc-angle) (- i 1)))))
  (iter 0 n))
(clearscreen)
(moveoncircle tu3 120 5 288 2))))


(define Xmastree (cons 'begin '(
(define (XTree turtle d a n)
  (if (>= n 1)
      (begin
      (forward turtle d)
      (right turtle a)
      (XTree turtle (/ d 2) a (- n 1))
      (left turtle a)
      (XTree turtle d a (- n 1))
      (left turtle a)
      (XTree turtle (/ d 2) a (- n 1))
      (right turtle a)
      (penup turtle)
      (back turtle d)
      (pendown turtle))))

(define (XmasTree turtle)
  (begin
    (clearscreen)
    (pendown turtle)
    (setpencolor turtle "green")
    (setpenwidth turtle 1)
    (setpos turtle -190 -160)
    (XTree turtle 60 60 7)
    (setpos turtle -50 100)
    (setpencolor turtle "blue")
    (XTree turtle 50 45 5)))
    
(clearscreen)
(maketurtle tu)
(XmasTree tu))))

(define Olympia (cons 'begin '(
(define (Krog turtle)
  (repeat 360
          (penup turtle)
          (forward turtle 70)
          (pendown turtle)
          (forward turtle 7)
          (penup turtle)
          (back turtle 77)
          (left turtle 1)))

(define (Olympia turtle)
  (begin
    (setpenwidth turtle 3)
    (forward turtle 50)
    (right turtle 90)
    (forward turtle 165)
    (left turtle 90)
    (setpencolor turtle "red")
    (krog turtle)
    (left turtle 90)
    (setpencolor turtle "yellow")
    (forward turtle 165)
    (krog turtle)
    (setpencolor turtle "blue")
    (forward turtle 165)
    (krog turtle)
    (setpencolor turtle "silver")
    (right turtle 40)
    (back turtle 110)
    (right turtle 140)
    (krog turtle)
    (forward turtle 165)
    (setpencolor turtle "green")
    (krog turtle)))

(clearscreen)
(maketurtle tu)
(olympia tu))))

(define dragon (cons 'begin '(
(define (drag turtle n a h)
  (if (< n 1) (begin (forward turtle h))
      (begin
      (drag turtle (- n 1) 90 h)
      (right turtle a)
      (drag turtle (- n 1) -90 h))))

(define (dragon turtle)
  (begin
   (pendown turtle)
   (setpencolor turtle "black")
   (setpenwidth turtle 2)
   (clearscreen)
   (setpos turtle 90 -200)
   (pendown turtle)
   (drag turtle 11 90 7)))
   
(clearscreen)
(maketurtle tu)
(dragon tu))))

(define Hilbert (cons 'begin '(
(define (Hilb turtle n a h)
  (if (not (= n 0))
      (begin
        (right turtle a)
        (Hilb turtle (- n 1) (- a) h)
        (forward turtle h)
        (left turtle a)
        (Hilb turtle (- n 1) a h)
        (forward turtle h)
        (Hilb turtle (- n 1) a h)
        (left turtle a)
        (forward turtle h)
        (hilb turtle (- n 1) (- a) h)
        (right turtle a))))
  
(define (Hilbert turtle)
  (begin
  (pendown tu)
  (setpos turtle -160 -160)
  (setpencolor turtle "blue")
  (setpenwidth turtle 2)
  (hilb turtle 5 90 10)))

(clearscreen)
(maketurtle tu)
(hilbert tu))))   

(define Flower (cons 'begin '(
(define (square turtle a)
(repeat 4
        (forward turtle a)
        (right turtle 90)))


(define (flowr turtle x y a)
(begin
(setpos turtle x y)
(pendown turtle)
(repeat 36
(penup turtle)
(forward turtle (/ a 36))
(pendown turtle)
(square turtle a)
(left turtle 10))))
        


(define (flower tu)
  (begin
  (setpenwidth tu 3)
  (setpencolor tu "red")
  (flowr tu 0 0 90)
   (setpenwidth tu 2)
  (setpencolor tu "yellow")
  (flowr tu 0 0 90)
   (setpenwidth tu 1)
  (setpencolor tu "blue")
  (flowr tu 0 0 90)))

(clearscreen)
(maketurtle tu)
(flower tu)))) 

(define Pinetree (cons 'begin '(
(define (pine turtle)
  (begin
    (setpencolor turtle "dark green")
    (setpenwidth turtle 2)
    (forward turtle 10)
    (left turtle 30)
    (setpenwidth turtle 1)
    (repeat 6
            (forward turtle 10)
            (back turtle 10)
            (right turtle 12))
    (setpenwidth turtle 2)
    (left turtle 42)
    (back turtle 10)
    (setpencolor turtle "green")))


(define (Trunk turtle n d)
  (if (not (= n 0))
      (begin
        (setpencolor turtle "green")
        (setpenwidth turtle (* 2 (- n 1)))
        (forward turtle d)
        (right turtle 45)
        (Trunk turtle (- n 1) (* d 0.7))
        (left turtle 45)
        (forward turtle d)
        (left turtle 30)
        (Trunk turtle (- n 1) (* d 0.5))
        (right turtle 30)
        (back turtle (* d 2))
        (setpenwidth turtle (* 2 (+ n 1))))))
                        
                 

(define (PineTree turtle)
  (begin
    (setpos turtle -100 0)
    (pendown turtle)
    (Trunk turtle 8 80)))

(clearscreen)
(maketurtle tu)
(PineTree tu))))  




(define ramo (cons 'begin '(
(define (farn a)
    (clearscreen)
    (maketurtle t)
    (setpos t -100 200)
    (pendown t)
    (left t 80)
    (define (farn-it n)
      (cond ((<= n 0) (forward t 3))
            ((even? n) (forward t (* n 3))
             (pushturtle t)
             (left t 50)
             (farn-it (quotient n 2))
             (popturtle t)
             (right t 5)
             (farn-it (- n 1)))
            (else (forward t (* n 3))
                  (pushturtle t)
                  (right t 50)
                  (farn-it (quotient n 2))
                  (popturtle t)
                  (right t 5)
                  (farn-it (- n 1)))))
    (farn-it a))

(farn 18))))
                               
                               
                      
                              


    